unit DtPop97;

(******************************************************************************
tDtCalPop97

This form unit is used by the DateEdit97 component.

Author name=BOURMAD Mehdi
Author E-mail=bourmad@multimania.com
Author URL=www.multimania.com/bourmad
******************************************************************************)

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Dialogs, Forms, StdCtrls, ExtCtrls, DtCal97, DtFunc97, DtMisc97;

type
  TDtCalPop97 = class(TForm)
    Calendar97: TCalendar97;
    procedure FormShow(Sender: TObject);
    procedure Calendar97KeyCancel(Sender: TObject);
    procedure Calendar97KeyEnter(Sender: TObject);
    procedure Calendar97DateClick(Sender: TObject);
    procedure Calendar97KillFocus(Sender: TObject);
  private
    procedure ClosePopup;
    procedure WMMouseActivate(var Message: TWMActivate); Message WM_MOUSEACTIVATE;
    procedure WMGetDlgCode(var Message: TWMGetDlgCode); message WM_GETDLGCODE;
  protected
  public
    MemorizedDate : tDateTime;
    aDateParent: tWinControl;
    cancel: boolean;
    constructor Create(AOwner: TComponent); override;
  end;

implementation

uses
  DtEdit97;

{$R *.DFM}

{************************** Create ************************}
constructor TDtCalPop97.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  if assigned(aOwner)
  and (aOwner is tWinControl)
  then begin
    aDateParent := aOwner as tWinControl;
    Parent := aDateParent.Parent;
  end
  else begin
    aDateParent := nil;
    Parent := nil;
  end;
  Calendar97.ShowCancel := true;
end;

procedure TDtCalPop97.FormShow(Sender: TObject);
var
  RectPlace  : tRect;
  nPoint, ptUpper, ptLower: TPoint;
begin
  Calendar97.SetIdealSize;
  {Initialize form Height & Width based on Font }
  {Dynamically set the size and position}
  if assigned(aDateParent)
  then begin
    RectPlace := aDateParent.ClientRect;

    PtUpper.X := RectPlace.Left;
    PtUpper.Y := RectPlace.Top;
    PtUpper := aDateParent.ClientToScreen(PtUpper);
    PtLower.X := RectPlace.Right;
    PtLower.Y := RectPlace.Bottom;
    PtLower := aDateParent.ClientToScreen(PtLower);
    {if too far down, pop the calendar above the control}
    if PtUpper.X + 1 + Width > Screen.Width
      then nPoint.X := Screen.Width - Width - 1
      else nPoint.X := PtUpper.X + 1;
    if PtLower.Y + 1 + Height > Screen.Height
      then nPoint.Y := ptUpper.Y - Height
      else nPoint.Y := PtLower.Y + 1;

{    SetBounds (nPoint.X, nPoint.Y,
               Width-ClientWidth+Calendar97.Width,
               Height-ClientHeight+Calendar97.Height);}
    Left := nPoint.X;
    Top := nPoint.Y;
    ClientWidth := Calendar97.Width;
    ClientHeight := Calendar97.Height;
  end
  else begin
    ClientWidth := Calendar97.Width;
    ClientHeight := Calendar97.Height;
  end;
  cancel := false;
  MemorizedDate := Calendar97.Date;
end;

procedure TDtCalPop97.ClosePopup;
begin
  Close;
  if Cancel
  then begin
    ModalResult := mrCancel;
    Calendar97.Date := MemorizedDate;
  end
  else
    ModalResult := mrOk;
end;

{********************** WMMouseActivate *******************
 ***  These functions hide calendar when it loose focus ***
 **********************************************************}
procedure TDtCalPop97.WMMouseActivate(var Message: TWMActivate);
begin
  inherited;
  Message.Result := MA_NOACTIVATE;
end;

procedure TDtCalPop97.WMGetDlgCode(var Message: TWMGetDlgCode);
begin
  Message.Result := DLGC_WANTARROWS;
end;

procedure TDtCalPop97.Calendar97KeyCancel(Sender: TObject);
begin
  Cancel := true;
  ClosePopup;
end;

procedure TDtCalPop97.Calendar97KeyEnter(Sender: TObject);
begin
  Cancel := false;
  ClosePopup;
end;

procedure TDtCalPop97.Calendar97DateClick(Sender: TObject);
begin
  Cancel := false;
  ClosePopup;
end;

procedure TDtCalPop97.Calendar97KillFocus(Sender: TObject);
begin
{  Cancel := false;}
  if Visible
    then ClosePopup;
end;

end.
